ClassDefinition (Java SE 26 & JDK 26)
Description: declaration: module: java.instrument, package: java.lang.instrument, class: ClassDefinition
Keywords: java.lang.instrument.ClassDefinition class

# Class ClassDefinition

java.lang.Object
java.lang.instrument.ClassDefinition

public final class ClassDefinition extends Object
This class serves as a parameter block to the `Instrumentation.redefineClasses` method. Serves to bind the `Class` that needs redefining together with the new class file bytes.

Since:
  1.5
See Also:
  - `Instrumentation.redefineClasses(ClassDefinition...)`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ClassDefinition(Class<?> theClass, byte[] theClassFile)`
  Creates a new `ClassDefinition` binding using the supplied class and class file bytes.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Class<?>`
  `getDefinitionClass()`
  Returns the class.
  `byte[]`
  `getDefinitionClassFile()`
  Returns the array of bytes that contains the new class file.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### ClassDefinition

    public ClassDefinition(Class<?> theClass, byte[] theClassFile)
    Creates a new `ClassDefinition` binding using the supplied class and class file bytes. Does not copy the supplied buffer, just captures a reference to it.
    Parameters:
      `theClass` - the `Class` that needs redefining
      `theClassFile` - the new class file bytes
    Throws:
      `NullPointerException` - if the supplied class or array is `null`.

- ## Method Details

  - ### getDefinitionClass

    public Class<?> getDefinitionClass()
    Returns the class.
    Returns:
      the `Class` object referred to.

  - ### getDefinitionClassFile

    public byte[] getDefinitionClassFile()
    Returns the array of bytes that contains the new class file.
    Returns:
      the class file bytes.